import _extends from "@babel/runtime/helpers/esm/extends";
import React, { useContext } from 'react';
import { createEntity } from './createEntity';
import EntityContext from './EntityContext';
export var EntityScope = function EntityScope(_ref) {
  var entities = _ref.entities,
      children = _ref.children;
  if (typeof entities !== 'object') throw new Error('EntityScope expects `entities` prop of object type.');
  var inheritedEntities = useContext(EntityContext);
  entities = _extends({}, inheritedEntities, {}, entities);

  for (var k in entities) {
    if (entities[k].subscribers === undefined) entities[k] = createEntity(entities[k]);
  }

  return /*#__PURE__*/React.createElement(EntityContext.Provider, {
    value: entities
  }, children);
};
export default EntityScope;